BeerOverflow/BeerOverflow.Web/Controllers/BeersController.cs
using BeerOverflow.Services.Contracts;
using BeerOverflow.Services.DTOs;
using BeerOverflow.Web.Mappers;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using System.Linq;
using System.Threading.Tasks;

namespace BeerOverflow.Web.Controllers
{
    public class BeersController : Controller
    {
        private readonly IBeerService _beerService;
        private readonly IStyleService _styleService;
        private readonly IBreweryService _breweryService;
        private readonly ICountryService _countryService;
        private readonly IReviewService _reviewService;
        private readonly IRatingService _ratingService;

        public BeersController(IBeerService beerService, IStyleService styleService,
            IBreweryService breweryService, ICountryService countryService, IReviewService reviewService,
            IRatingService ratingService)
        {
            _beerService = beerService;
            _styleService = styleService;
            _breweryService = breweryService;
            _countryService = countryService;
            _reviewService = reviewService;
            _ratingService = ratingService;
        }

        public async Task<ActionResult> Index(string filterBy, string filter, string sortString = "", int page = 1, string search = "")
        {
            ViewData["Styles"] = (await _styleService.GetMany()).Select(x => x.Name);
            ViewData["Breweries"] = (await _breweryService.GetMany()).Select(x => x.Name);
            ViewData["Countries"] = (await _countryService.GetMany()).Select(x => x.Name);

            return sortString switch
            {
                "name" => View((await _beerService.GetMany(filterBy, sortString, filterValue: filter, page: page, searchQuery:search)
                    ).Select(x => x.ToViewModel())),

                "country" => View((await _beerService.GetMany(filterBy, sortString, filterValue: filter, page: page, searchQuery: search)
                    ).Select(x => x.ToViewModel())),

                "abv-low" => View((await _beerService.GetMany(filterBy, "abv", filterValue: filter, page: page, searchQuery: search)
                    ).Select(x => x.ToViewModel())),

                "abv-high" => View((await _beerService.GetMany(filterBy, "abv", filterValue: filter, page: page, order: "desc", searchQuery: search)
                    ).Select(x => x.ToViewModel())),

                "rating-low" => View((await _beerService.GetMany(filterBy, "rating", filterValue: filter, page: page, searchQuery: search)
                    ).Select(x => x.ToViewModel())),

                "rating-high" => View((await _beerService.GetMany(filterBy, "rating", filterValue: filter, page: page, order: "desc", searchQuery: search)
                    ).Select(x => x.ToViewModel())),

                _ => View((await _beerService.GetMany(filterBy, filterValue: filter, page: page, searchQuery: search)
                    ).Select(x => x.ToViewModel())),
            };
        }

        public async Task<ActionResult> Details(int id)
        {
            var beer = await _beerService.Get(id);
            return View(beer.ToViewModel());
        }

        public async Task<ActionResult> Create()
        {
            ViewData["StyleID"] = new SelectList(await _styleService.GetMany(), "ID", "Name");
            ViewData["BreweryID"] = new SelectList(await _breweryService.GetMany(), "ID", "Name");
            return View();
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Create(BeerDTO beerDTO)
        {
            if (ModelState.IsValid)
            {
                try
                {
                    await _beerService.Create(beerDTO);
                }
                catch
                {
                    return RedirectToAction(nameof(Index));
                }
            }

            return RedirectToAction(nameof(Index));
        }

        [Authorize(Roles = "Admin")]
        public async Task<ActionResult> Edit(int id)
        {
            ViewData["StyleID"] = new SelectList(await _styleService.GetMany(), "ID", "Name");
            ViewData["BreweryID"] = new SelectList(await _breweryService.GetMany(), "ID", "Name");

            var beer = await _beerService.Get(id);
            return View(beer);
        }

        [HttpPost]
        [Authorize(Roles = "Admin")]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Edit(int id, BeerDTO beerDTO)
        {
            try
            {
                await _beerService.Update(id, beerDTO);
                return Redirect($"/Beers/Details/{id}");
            }
            catch
            {
                return View();
            }
        }

        [HttpPost]
        [Authorize(Roles = "User, Admin")]
        public async Task<IActionResult> Review(int userId, int beerId)
        {
            try
            {
                string body = Request.Form["reviewBody"];
                int rating = int.Parse(Request.Form["userRating"]);
                await _reviewService.Create(userId, beerId, body);
                await _ratingService.Create(new RatingDTO { BeerID = beerId, UserID = userId, Value = rating });
            }
            catch
            {
            }

            return Redirect($"Details/{beerId}");
        }

        [HttpPost]
        [Authorize(Roles = "User, Admin")]
        public async Task<IActionResult> Like(int reviewId, int beerId)
        {
            try
            {
                await _reviewService.Like(reviewId);
            }
            catch
            {
            }

            return Redirect($"Details/{beerId}");
        }

        [Authorize(Roles = "Admin")]
        public ActionResult Delete(int id)
        {
            return View();
        }

        [HttpPost]
        [Authorize(Roles = "Admin")]
        [ValidateAntiForgeryToken]
        public ActionResult Delete(int id, IFormCollection collection)
        {
            try
            {
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }
    }
}

BeerOverflow/BeerOverflow.Web/Controllers/UsersController.cs
using BeerOverflow.Services.Contracts;
using BeerOverflow.Services.DTOs;
using BeerOverflow.Web.Mappers;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using System.Linq;
using System.Threading.Tasks;

namespace BeerOverflow.Web.Controllers
{
    [Authorize(Roles = "Admin")]
    public class UsersController : Controller
    {
        private readonly IUserService _userService;

        public UsersController(IUserService userService)
        {
            _userService = userService;
        }

        public async Task<ActionResult> Index()
        {
            return View(
                (await _userService.GetMany(null, null))
                .Select(async x => x.ToViewModel(await _userService.GetRole(x.ID)))
                .Select(t => t.Result));
        }

        public async Task<ActionResult> Details(int id)
        {
            var user = await _userService.Get(id);
            return View(user.ToViewModel(await _userService.GetRole(id)));
        }

        public ActionResult Create()
        {
            return View();
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Create(UserDTO userDTO)
        {
            try
            {
                await _userService.Create(userDTO);
            }
            catch
            {
                return View();
            }

            return RedirectToAction(nameof(Index));
        }

        public async Task<ActionResult> Edit(int id)
        {
            var user = await _userService.Get(id);
            user.Role = await _userService.GetRole(id);
            ViewData["Roles"] = new SelectList(await _userService.GetAllRoles());
            return View(user);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Edit(int id, UserDTO userDTO)
        {
            try
            {
                await _userService.Update(id, userDTO);
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        public async Task<ActionResult> Delete(int id)
        {
            var user = await _userService.Get(id);
            return View(user.ToViewModel(await _userService.GetRole(id)));
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Delete(int id, UserDTO user)
        {
            try
            {
                await _userService.RemoveFromDb(id);
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        public async Task<ActionResult> Ban(int id)
        {
            var user = await _userService.Get(id);
            return View(user.ToViewModel(await _userService.GetRole(id)));
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Ban(int id, UserDTO user)
        {
            try
            {
                string desc = Request.Form["banDescription"];
                await _userService.Ban(id, desc);
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        public async Task<ActionResult> Unban(int id)
        {
            var user = await _userService.Get(id);
            return View(user.ToViewModel(await _userService.GetRole(id)));
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Unban(int id, UserDTO user)
        {
            try
            {
                await _userService.Unban(id);
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }
    }
}

BeerOverflow/BeerOverflow.Web/Views/Shared/_Layout.cshtml
@using Microsoft.AspNetCore.Identity
@using BeerOverflow.Models

@inject SignInManager<User> SignInManager
@inject UserManager<User> UserManager
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <title>@ViewData["Title"] - BeerOverflow</title>
    <meta name="description" content="">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="robots" content="all,follow">
    <!-- Bootstrap CSS-->
    <link rel="stylesheet" href="@Url.Content("~/vendor/bootstrap/css/bootstrap.min.css")">
    <!-- Lightbox-->
    <link rel="stylesheet" href="@Url.Content("~/vendor/lightbox2/css/lightbox.min.css")">
    <!-- Range slider-->
    <link rel="stylesheet" href="@Url.Content("~/vendor/nouislider/nouislider.min.css")">
    <!-- Bootstrap select-->
    <link rel="stylesheet" href="@Url.Content("~/vendor/bootstrap-select/css/bootstrap-select.min.css")">
    <!-- Owl Carousel-->
    <link rel="stylesheet" href="@Url.Content("~/vendor/owl.carousel2/assets/owl.carousel.min.css")">
    <link rel="stylesheet" href="@Url.Content("~/vendor/owl.carousel2/assets/owl.theme.default.css")">
    <!-- Google fonts-->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css2?family=Libre+Franklin:wght@300;400;700&amp;display=swap">
    <link rel="stylesheet" href="https://fonts.googleapis.com/css2?family=Martel+Sans:wght@300;400;800&amp;display=swap">
    <!-- theme stylesheet-->
    <link rel="stylesheet" href="@Url.Content("~/css/style.default.css")" id="theme-stylesheet">
    <!-- Custom stylesheet - for your changes-->
    <link rel="stylesheet" href="@Url.Content("~/css/custom.css")">
    <!-- Favicon-->
    <link rel="shortcut icon" href="@Url.Content("~/img/favicon.ico")">
</head>
<body>

    <div class="page-holder">

        <partial name="_NavbarPartial" />
        
        <div class="container">
            <section class="py-5">
                @RenderBody()
            </section>
        </div>
    </div>

    <script src="@Url.Content("~/vendor/jquery/jquery.min.js")"></script>
    <script src="@Url.Content("~/vendor/bootstrap/js/bootstrap.bundle.min.js")"></script>
    <script src="@Url.Content("~/vendor/lightbox2/js/lightbox.min.js")"></script>
    <script src="@Url.Content("~/vendor/nouislider/nouislider.min.js")"></script>
    <script src="@Url.Content("~/vendor/bootstrap-select/js/bootstrap-select.min.js")"></script>
    <script src="@Url.Content("~/vendor/owl.carousel2/owl.carousel.min.js")"></script>
    <script src="@Url.Content("~/vendor/owl.carousel2.thumbs/owl.carousel2.thumbs.min.js")"></script>
    <script src="@Url.Content("~/js/front.js")"></script>

    @RenderSection("Scripts", required: false)
    <!-- FontAwesome CSS - loading as last, so it doesn't block rendering-->
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.7.1/css/all.css" integrity="sha384-fnmOCqbTlWIlj8LyTjo7mOUStjsKC4pOpQbqyi7RrhN7udi9RwhKkMHpvLbHG9Sr" crossorigin="anonymous">
</body>
</html>

BeerOverflow/BeerOverflow.Web/Views/Shared/_NavbarPartial.cshtml
<header class="header bg-white">
    <div class="container px-0 px-lg-3">
        <nav class="navbar navbar-expand-lg navbar-light py-3 px-lg-0">
            <a class="navbar-brand" href="index.html"><span class="font-weight-bold text-uppercase text-dark">BeerOverflow</span></a>
            <button class="navbar-toggler navbar-toggler-right" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation"><span class="navbar-toggler-icon"></span></button>
            <div class="collapse navbar-collapse" id="navbarSupportedContent">
                <ul class="navbar-nav mr-auto">
                    <li class="nav-item">
                        <a class="nav-link" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" asp-area="" asp-controller="Beers" asp-action="Index">Beers</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" asp-area="" asp-controller="Breweries" asp-action="Index">Breweries</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" asp-area="" asp-controller="Styles" asp-action="Index">Styles</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" asp-area="" asp-controller="Countries" asp-action="Index">Countries</a>
                    </li>
                    @if (User.IsInRole("Admin"))
                    {
                        <li class="nav-item">
                            <a class="nav-link" asp-area="" asp-controller="Users" asp-action="Index">Users</a>
                        </li>
                    }
                </ul>
                <partial name="_LoginPartial" />
            </div>
        </nav>
    </div>
</header>